*** a/src/include/nodes/print.h
--- b/src/include/nodes/print.h
***************
*** 15,20 ****
--- 15,21 ----
  #define PRINT_H
  
  #include "executor/tuptable.h"
+ #include "lib/stringinfo.h"
  
  
  #define nodeDisplay(x)		pprint(x)
*** a/src/include/parser/parse_oper.h
--- b/src/include/parser/parse_oper.h
***************
*** 14,20 ****
  #ifndef PARSE_OPER_H
  #define PARSE_OPER_H
  
! #include "access/htup.h"
  #include "parser/parse_node.h"
  
  
--- 14,20 ----
  #ifndef PARSE_OPER_H
  #define PARSE_OPER_H
  
! #include "access/tupbasics.h"
  #include "parser/parse_node.h"
  
  
*** a/src/include/parser/parse_type.h
--- b/src/include/parser/parse_type.h
***************
*** 13,19 ****
  #ifndef PARSE_TYPE_H
  #define PARSE_TYPE_H
  
! #include "access/htup.h"
  #include "parser/parse_node.h"
  
  
--- 13,19 ----
  #ifndef PARSE_TYPE_H
  #define PARSE_TYPE_H
  
! #include "access/tupbasics.h"
  #include "parser/parse_node.h"
  
  
*** a/src/include/storage/predicate.h
--- b/src/include/storage/predicate.h
***************
*** 14,19 ****
--- 14,20 ----
  #ifndef PREDICATE_H
  #define PREDICATE_H
  
+ #include "storage/block.h"
  #include "utils/relcache.h"
  #include "utils/snapshot.h"
  
*** a/src/include/tcop/pquery.h
--- b/src/include/tcop/pquery.h
***************
*** 16,21 ****
--- 16,22 ----
  
  #include "nodes/parsenodes.h"
  #include "utils/portal.h"
+ #include "tcop/dest.h"
  
  
  extern PGDLLIMPORT Portal ActivePortal;
*** a/src/include/tcop/tcopprot.h
--- b/src/include/tcop/tcopprot.h
***************
*** 19,26 ****
  #ifndef TCOPPROT_H
  #define TCOPPROT_H
  
! #include "executor/execdesc.h"
  #include "nodes/parsenodes.h"
  #include "storage/procsignal.h"
  #include "utils/guc.h"
  
--- 19,27 ----
  #ifndef TCOPPROT_H
  #define TCOPPROT_H
  
! #include "nodes/params.h"
  #include "nodes/parsenodes.h"
+ #include "nodes/plannodes.h"
  #include "storage/procsignal.h"
  #include "utils/guc.h"
  
*** a/src/include/utils/catcache.h
--- b/src/include/utils/catcache.h
***************
*** 20,27 ****
  #ifndef CATCACHE_H
  #define CATCACHE_H
  
- #include "access/htup.h"
  #include "access/skey.h"
  #include "lib/dllist.h"
  #include "utils/relcache.h"
  
--- 20,27 ----
  #ifndef CATCACHE_H
  #define CATCACHE_H
  
  #include "access/skey.h"
+ #include "access/tupbasics.h"
  #include "lib/dllist.h"
  #include "utils/relcache.h"
  
*** a/src/include/utils/guc.h
--- b/src/include/utils/guc.h
***************
*** 13,18 ****
--- 13,19 ----
  #ifndef GUC_H
  #define GUC_H
  
+ #include "access/tupdesc.h"
  #include "nodes/parsenodes.h"
  #include "tcop/dest.h"
  #include "utils/array.h"
*** a/src/include/utils/inval.h
--- b/src/include/utils/inval.h
***************
*** 14,20 ****
  #ifndef INVAL_H
  #define INVAL_H
  
! #include "access/htup.h"
  #include "utils/relcache.h"
  
  
--- 14,21 ----
  #ifndef INVAL_H
  #define INVAL_H
  
! #include "access/tupbasics.h"
! #include "storage/relfilenode.h"
  #include "utils/relcache.h"
  
  
*** a/src/include/utils/lsyscache.h
--- b/src/include/utils/lsyscache.h
***************
*** 13,19 ****
  #ifndef LSYSCACHE_H
  #define LSYSCACHE_H
  
! #include "access/htup.h"
  
  /* Result list element for get_op_btree_interpretation */
  typedef struct OpBtreeInterpretation
--- 13,22 ----
  #ifndef LSYSCACHE_H
  #define LSYSCACHE_H
  
! #include "access/attnum.h"
! #include "access/tupbasics.h"
! #include "nodes/pg_list.h"
! #include "nodes/nodes.h"
  
  /* Result list element for get_op_btree_interpretation */
  typedef struct OpBtreeInterpretation
*** a/src/include/utils/portal.h
--- b/src/include/utils/portal.h
***************
*** 48,54 ****
--- 48,56 ----
  
  #include "datatype/timestamp.h"
  #include "executor/execdesc.h"
+ #include "utils/plancache.h"
  #include "utils/resowner.h"
+ #include "utils/tuplestore.h"
  
  /*
   * We have several execution strategies for Portals, depending on what
*** a/src/include/utils/resowner.h
--- b/src/include/utils/resowner.h
***************
*** 19,30 ****
  #ifndef RESOWNER_H
  #define RESOWNER_H
  
- #include "storage/fd.h"
- #include "storage/lock.h"
- #include "utils/catcache.h"
- #include "utils/plancache.h"
- #include "utils/snapshot.h"
- 
  
  /*
   * ResourceOwner objects are an opaque data structure known only within
--- 19,24 ----
***************
*** 85,144 **** extern void RegisterResourceReleaseCallback(ResourceReleaseCallback callback,
  extern void UnregisterResourceReleaseCallback(ResourceReleaseCallback callback,
  								  void *arg);
  
- /* support for buffer refcount management */
- extern void ResourceOwnerEnlargeBuffers(ResourceOwner owner);
- extern void ResourceOwnerRememberBuffer(ResourceOwner owner, Buffer buffer);
- extern void ResourceOwnerForgetBuffer(ResourceOwner owner, Buffer buffer);
- 
- /* support for local lock management */
- extern void ResourceOwnerRememberLock(ResourceOwner owner, LOCALLOCK *locallock);
- extern void ResourceOwnerForgetLock(ResourceOwner owner, LOCALLOCK *locallock);
- 
- /* support for catcache refcount management */
- extern void ResourceOwnerEnlargeCatCacheRefs(ResourceOwner owner);
- extern void ResourceOwnerRememberCatCacheRef(ResourceOwner owner,
- 								 HeapTuple tuple);
- extern void ResourceOwnerForgetCatCacheRef(ResourceOwner owner,
- 							   HeapTuple tuple);
- extern void ResourceOwnerEnlargeCatCacheListRefs(ResourceOwner owner);
- extern void ResourceOwnerRememberCatCacheListRef(ResourceOwner owner,
- 									 CatCList *list);
- extern void ResourceOwnerForgetCatCacheListRef(ResourceOwner owner,
- 								   CatCList *list);
- 
- /* support for relcache refcount management */
- extern void ResourceOwnerEnlargeRelationRefs(ResourceOwner owner);
- extern void ResourceOwnerRememberRelationRef(ResourceOwner owner,
- 								 Relation rel);
- extern void ResourceOwnerForgetRelationRef(ResourceOwner owner,
- 							   Relation rel);
- 
- /* support for plancache refcount management */
- extern void ResourceOwnerEnlargePlanCacheRefs(ResourceOwner owner);
- extern void ResourceOwnerRememberPlanCacheRef(ResourceOwner owner,
- 								  CachedPlan *plan);
- extern void ResourceOwnerForgetPlanCacheRef(ResourceOwner owner,
- 								CachedPlan *plan);
- 
- /* support for tupledesc refcount management */
- extern void ResourceOwnerEnlargeTupleDescs(ResourceOwner owner);
- extern void ResourceOwnerRememberTupleDesc(ResourceOwner owner,
- 							   TupleDesc tupdesc);
- extern void ResourceOwnerForgetTupleDesc(ResourceOwner owner,
- 							 TupleDesc tupdesc);
- 
- /* support for snapshot refcount management */
- extern void ResourceOwnerEnlargeSnapshots(ResourceOwner owner);
- extern void ResourceOwnerRememberSnapshot(ResourceOwner owner,
- 							  Snapshot snapshot);
- extern void ResourceOwnerForgetSnapshot(ResourceOwner owner,
- 							Snapshot snapshot);
- 
- /* support for temporary file management */
- extern void ResourceOwnerEnlargeFiles(ResourceOwner owner);
- extern void ResourceOwnerRememberFile(ResourceOwner owner,
- 						  File file);
- extern void ResourceOwnerForgetFile(ResourceOwner owner,
- 						File file);
- 
  #endif   /* RESOWNER_H */
--- 79,82 ----
*** /dev/null
--- b/src/include/utils/resowner_private.h
***************
*** 0 ****
--- 1,83 ----
+ /*-------------------------------------------------------------------------
+  *
+  * resowner_private.h
+  *	  POSTGRES resource owner private definitions.
+  *
+  * See utils/resowner/README for more info.
+  *
+  *
+  * Portions Copyright (c) 1996-2012, PostgreSQL Global Development Group
+  * Portions Copyright (c) 1994, Regents of the University of California
+  *
+  * src/include/utils/resowner_private.h
+  *
+  *-------------------------------------------------------------------------
+  */
+ #ifndef RESOWNER_PRIVATE_H
+ #define RESOWNER_PRIVATE_H
+ 
+ #include "storage/fd.h"
+ #include "storage/lock.h"
+ #include "utils/catcache.h"
+ #include "utils/plancache.h"
+ #include "utils/resowner.h"
+ #include "utils/snapshot.h"
+ 
+ 
+ /* support for buffer refcount management */
+ extern void ResourceOwnerEnlargeBuffers(ResourceOwner owner);
+ extern void ResourceOwnerRememberBuffer(ResourceOwner owner, Buffer buffer);
+ extern void ResourceOwnerForgetBuffer(ResourceOwner owner, Buffer buffer);
+ 
+ /* support for local lock management */
+ extern void ResourceOwnerRememberLock(ResourceOwner owner, LOCALLOCK *locallock);
+ extern void ResourceOwnerForgetLock(ResourceOwner owner, LOCALLOCK *locallock);
+ 
+ /* support for catcache refcount management */
+ extern void ResourceOwnerEnlargeCatCacheRefs(ResourceOwner owner);
+ extern void ResourceOwnerRememberCatCacheRef(ResourceOwner owner,
+ 								 HeapTuple tuple);
+ extern void ResourceOwnerForgetCatCacheRef(ResourceOwner owner,
+ 							   HeapTuple tuple);
+ extern void ResourceOwnerEnlargeCatCacheListRefs(ResourceOwner owner);
+ extern void ResourceOwnerRememberCatCacheListRef(ResourceOwner owner,
+ 									 CatCList *list);
+ extern void ResourceOwnerForgetCatCacheListRef(ResourceOwner owner,
+ 								   CatCList *list);
+ 
+ /* support for relcache refcount management */
+ extern void ResourceOwnerEnlargeRelationRefs(ResourceOwner owner);
+ extern void ResourceOwnerRememberRelationRef(ResourceOwner owner,
+ 								 Relation rel);
+ extern void ResourceOwnerForgetRelationRef(ResourceOwner owner,
+ 							   Relation rel);
+ 
+ /* support for plancache refcount management */
+ extern void ResourceOwnerEnlargePlanCacheRefs(ResourceOwner owner);
+ extern void ResourceOwnerRememberPlanCacheRef(ResourceOwner owner,
+ 								  CachedPlan *plan);
+ extern void ResourceOwnerForgetPlanCacheRef(ResourceOwner owner,
+ 								CachedPlan *plan);
+ 
+ /* support for tupledesc refcount management */
+ extern void ResourceOwnerEnlargeTupleDescs(ResourceOwner owner);
+ extern void ResourceOwnerRememberTupleDesc(ResourceOwner owner,
+ 							   TupleDesc tupdesc);
+ extern void ResourceOwnerForgetTupleDesc(ResourceOwner owner,
+ 							 TupleDesc tupdesc);
+ 
+ /* support for snapshot refcount management */
+ extern void ResourceOwnerEnlargeSnapshots(ResourceOwner owner);
+ extern void ResourceOwnerRememberSnapshot(ResourceOwner owner,
+ 							  Snapshot snapshot);
+ extern void ResourceOwnerForgetSnapshot(ResourceOwner owner,
+ 							Snapshot snapshot);
+ 
+ /* support for temporary file management */
+ extern void ResourceOwnerEnlargeFiles(ResourceOwner owner);
+ extern void ResourceOwnerRememberFile(ResourceOwner owner,
+ 						  File file);
+ extern void ResourceOwnerForgetFile(ResourceOwner owner,
+ 						File file);
+ 
+ #endif   /* RESOWNER_PRIVATE_H */
*** a/src/include/utils/selfuncs.h
--- b/src/include/utils/selfuncs.h
***************
*** 16,22 ****
  #define SELFUNCS_H
  
  #include "fmgr.h"
! #include "access/htup.h"
  #include "nodes/relation.h"
  
  
--- 16,22 ----
  #define SELFUNCS_H
  
  #include "fmgr.h"
! #include "access/tupbasics.h"
  #include "nodes/relation.h"
  
  
*** a/src/include/utils/snapmgr.h
--- b/src/include/utils/snapmgr.h
***************
*** 13,19 ****
--- 13,21 ----
  #ifndef SNAPMGR_H
  #define SNAPMGR_H
  
+ #include "fmgr.h"
  #include "utils/resowner.h"
+ #include "utils/snapshot.h"
  
  
  extern bool FirstSnapshotSet;
*** a/src/include/utils/snapshot.h
--- b/src/include/utils/snapshot.h
***************
*** 13,19 ****
  #ifndef SNAPSHOT_H
  #define SNAPSHOT_H
  
! #include "access/htup.h"
  #include "storage/buf.h"
  
  
--- 13,19 ----
  #ifndef SNAPSHOT_H
  #define SNAPSHOT_H
  
! #include "access/tupbasics.h"
  #include "storage/buf.h"
  
  
*** a/src/include/utils/syscache.h
--- b/src/include/utils/syscache.h
***************
*** 16,22 ****
  #ifndef SYSCACHE_H
  #define SYSCACHE_H
  
! #include "utils/catcache.h"
  
  /*
   *		SysCache identifiers.
--- 16,24 ----
  #ifndef SYSCACHE_H
  #define SYSCACHE_H
  
! #include "access/attnum.h"
! #include "access/tupbasics.h"
! /* we purposedly do not include utils/catcache.h here */
  
  /*
   *		SysCache identifiers.
***************
*** 119,124 **** extern uint32 GetSysCacheHashValue(int cacheId,
--- 121,127 ----
  					 Datum key1, Datum key2, Datum key3, Datum key4);
  
  /* list-search interface.  Users of this must import catcache.h too */
+ struct catclist;
  extern struct catclist *SearchSysCacheList(int cacheId, int nkeys,
  				   Datum key1, Datum key2, Datum key3, Datum key4);
  
*** a/src/pl/plperl/plperl.c
--- b/src/pl/plperl/plperl.c
***************
*** 16,21 ****
--- 16,22 ----
  #include <locale.h>
  
  /* postgreSQL stuff */
+ #include "access/htup.h"
  #include "access/xact.h"
  #include "catalog/pg_language.h"
  #include "catalog/pg_proc.h"
*** a/src/pl/plpgsql/src/pl_comp.c
--- b/src/pl/plpgsql/src/pl_comp.c
***************
*** 17,22 ****
--- 17,23 ----
  
  #include <ctype.h>
  
+ #include "access/htup.h"
  #include "catalog/namespace.h"
  #include "catalog/pg_proc.h"
  #include "catalog/pg_proc_fn.h"
*** a/src/pl/plpgsql/src/pl_exec.c
--- b/src/pl/plpgsql/src/pl_exec.c
***************
*** 17,22 ****
--- 17,23 ----
  
  #include <ctype.h>
  
+ #include "access/htup.h"
  #include "access/transam.h"
  #include "access/tupconvert.h"
  #include "catalog/pg_proc.h"
*** a/src/pl/plpgsql/src/pl_handler.c
--- b/src/pl/plpgsql/src/pl_handler.c
***************
*** 15,20 ****
--- 15,21 ----
  
  #include "plpgsql.h"
  
+ #include "access/htup.h"
  #include "catalog/pg_proc.h"
  #include "catalog/pg_type.h"
  #include "funcapi.h"
*** a/src/pl/plpython/plpy_exec.c
--- b/src/pl/plpython/plpy_exec.c
***************
*** 6,11 ****
--- 6,12 ----
  
  #include "postgres.h"
  
+ #include "access/htup.h"
  #include "access/xact.h"
  #include "catalog/pg_type.h"
  #include "commands/trigger.h"
*** a/src/pl/plpython/plpy_main.c
--- b/src/pl/plpython/plpy_main.c
***************
*** 6,11 ****
--- 6,12 ----
  
  #include "postgres.h"
  
+ #include "access/htup.h"
  #include "catalog/pg_proc.h"
  #include "catalog/pg_type.h"
  #include "commands/trigger.h"
*** a/src/pl/plpython/plpy_procedure.c
--- b/src/pl/plpython/plpy_procedure.c
***************
*** 6,11 ****
--- 6,12 ----
  
  #include "postgres.h"
  
+ #include "access/htup.h"
  #include "access/transam.h"
  #include "funcapi.h"
  #include "catalog/pg_proc.h"
*** a/src/pl/plpython/plpy_spi.c
--- b/src/pl/plpython/plpy_spi.c
***************
*** 6,11 ****
--- 6,12 ----
  
  #include "postgres.h"
  
+ #include "access/htup.h"
  #include "access/xact.h"
  #include "catalog/pg_type.h"
  #include "executor/spi_priv.h"
*** a/src/pl/plpython/plpy_typeio.c
--- b/src/pl/plpython/plpy_typeio.c
***************
*** 6,11 ****
--- 6,12 ----
  
  #include "postgres.h"
  
+ #include "access/htup.h"
  #include "access/transam.h"
  #include "catalog/pg_type.h"
  #include "funcapi.h"
*** a/src/pl/plpython/plpy_typeio.h
--- b/src/pl/plpython/plpy_typeio.h
***************
*** 5,11 ****
  #ifndef PLPY_TYPEIO_H
  #define PLPY_TYPEIO_H
  
! #include "access/htup.h"
  #include "fmgr.h"
  #include "storage/itemptr.h"
  
--- 5,12 ----
  #ifndef PLPY_TYPEIO_H
  #define PLPY_TYPEIO_H
  
! #include "access/tupbasics.h"
! #include "access/tupdesc.h"
  #include "fmgr.h"
  #include "storage/itemptr.h"
  
*** a/src/pl/tcl/pltcl.c
--- b/src/pl/tcl/pltcl.c
***************
*** 18,23 ****
--- 18,24 ----
  #define CONST84
  #endif
  
+ #include "access/htup.h"
  #include "access/xact.h"
  #include "catalog/pg_proc.h"
  #include "catalog/pg_type.h"
